/*  $Id: SCBalloonTextView.java,v 1.18 2007/07/16 00:52:37 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCBalloonTextView extends NSView {
    private static final NSRange FIRSTCHAR_RANGE = new NSRange(0,1);
    private static final int SHADOW_INTERVAL = 2;
    private static final int LINE_INTERVAL = 0;
    
    NSFont font;
    float fontHeight;
    NSColor mainColor, mainShadowColor;
    
    float x, y;
    NSImage offscreen;
    
    float newline_ratio;

    SCBalloonScrollArrow arrow_up, arrow_down;
    
    public SCBalloonTextView(NSRect r) {
        // call this constructor only on the main thread
		super(r);

		setFont(NSFont.systemFontOfSize(10.0f));
		setMainColor(NSColor.blackColor());
		setMainShadowColor(null);
    }

    private void needOffscreen() {
        if (offscreen == null) {
            offscreen = new NSImage();
            cleanUp(); //  offscreen 𐳂TCYɂB
        }
    }
	
    public void initialize(
		SCBalloonScrollArrow arrow_up, SCBalloonScrollArrow arrow_down) {
	
		this.arrow_up = arrow_up;
		this.arrow_down = arrow_down;
    }

    public void close() {
		arrow_up = null;
		arrow_down = null;
    }

    public void setLocation(final int newX, final int newY) {
		/*
		  ̒l͓ʂȈӖB
	  
		  Integer.MIN_VALUE: lɐݒ
		  Integer.MAX_VALUE: ̍XȂ
		*/
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (newX == Integer.MIN_VALUE) {
                        x = superview().frame().width() / 2;
                    }
                    else if (newX == Integer.MAX_VALUE) {
	    
                    }
                    else {
                        x = newX;
                    }

                    if (newY == Integer.MIN_VALUE) {
                        // FIXME: {cɂŗǂ̂ǂc
                        y = superview().frame().height() / 2;
                        y -= fontHeight / 2;
                    }
                    else if (newY == Integer.MAX_VALUE) {

                    }
                    else {
                        y = frame().height() - fontHeight - newY;
                    }
                    
                    return null;
                }
            });
    }
    
    public void updateArrowsVisibilities() {
		// initialize()Ă΂Oɂ̃\bhĂ΂\B
		if (arrow_up != null) arrow_up.updateVisibility();
		if (arrow_down != null) arrow_down.updateVisibility();
    }
    
    private void addSubviewAtCurrentLoc(final NSView view) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    NSRect view_frame = view.frame();
                    float viewwidth = view_frame.width();
                    float viewheight = view_frame.height();
	
                    view.setFrame(new NSRect(x, y, viewwidth, viewheight));
                    addSubview(view);
                    x += viewwidth;

                    setNeedsDisplay(true);
                    return null;
                }
            });
    }
    
    public void changedSize() {
		// r[̂̂̃TCYύXKĂłB
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    NSRect frame = superview().frame();
                    setFrame(frame);
                    setOffscreenSize(frame.size());
                    
                    return null;
                }
            });
    }
    
    public void setFont(final NSFont f) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    font = f;
                    fontHeight = Math.round(font.boundingRectForFont().height());
                    
                    return null;
                }
            });
    }

    public final float getFontHeight() {
		return fontHeight;
    }
    
    public NSFont getFont() {
		return font;
    }
    
    public void setMainColor(NSColor c) {
		mainColor = c;
    }
    
    public NSColor getMainColor() {
		return mainColor;
    }
    
    public void setMainShadowColor(NSColor c) {
		// nullȂe𗎂Ƃ܂B
		mainShadowColor = c;
    }

    public void drawRect(NSRect r) {
        // call this method only on the main thread

        needOffscreen();
        
		offscreen.compositeToPointFromRect(
			r.origin(), r, NSImage.CompositeSourceOver);
    }
    public void drawImage(NSImage image, NSPoint point){
        // call this method only on the main thread

        needOffscreen();
        
		// FIXME: 摜subviewɂǂƎvBłʓ|Ȃ̂Ō񂵁B
        image.compositeToPoint(point,NSImage.CompositeCopy);
        NSRect r = new NSRect(0,0,image.size().width(),image.size().height());
        offscreen.compositeToPointFromRect(r.origin(),r,NSImage.CompositeSourceOver);

    }
    private NSMutableAttributedString astr, shadowstr;
    private void drawChar(final char c, final boolean redraw) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {

                    needOffscreen();

                    offscreen.lockFocus();
        
                    if (astr == null) {
                        astr = new NSMutableAttributedString(Character.toString(c));
                    }
                    else {
                        astr.replaceCharactersInRange(
                            FIRSTCHAR_RANGE, Character.toString(c));
                    }
                    astr.addAttributeInRange(
                        NSAttributedString.FontAttributeName, font, FIRSTCHAR_RANGE);
                    astr.addAttributeInRange(
                        NSAttributedString.ForegroundColorAttributeName, mainColor, FIRSTCHAR_RANGE);

                    if (mainShadowColor != null) {
                        if (shadowstr == null) {
                            shadowstr = new NSMutableAttributedString(astr); // copy
                        }
                        else {
                            shadowstr.replaceCharactersInRange(
                                FIRSTCHAR_RANGE, astr);
                        }
                        shadowstr.addAttributeInRange(
                            NSAttributedString.ForegroundColorAttributeName, mainShadowColor, FIRSTCHAR_RANGE);
                    }
	
                    final float widthOfCurrentChar =
                        NSGraphics.sizeOfAttributedString(astr).width();
                    // słȂĂA̕`悵ƂŔ͈͂𒴂悤ȂsB
                    if (c == '\n' || x + widthOfCurrentChar > frame().width()) {
                        x = 0;
                        if (c == '\n') {
                            y -= (float)Math.round(fontHeight * newline_ratio) + LINE_INTERVAL + SHADOW_INTERVAL;
                        }
                        else {
                            y -= fontHeight + LINE_INTERVAL + SHADOW_INTERVAL;
                        }
	    
                        final float screen_height = offscreen.size().height();
                        if (y < 0) { // y˂jt[găXN[B
                            float deltaY = -1 * y;
		
                            offscreen.unlockFocus();
                            NSRect oldframe = frame();
                            NSRect newframe = new NSRect(
                                0, 0, oldframe.width(), oldframe.height() + deltaY); // sg
                            setFrame(newframe);
                            setOffscreenSize(newframe.size());
                            offscreen.lockFocus();
		
                            updateArrowsVisibilities();
		
                            offscreen.compositeToPoint(
                                new NSPoint(0,deltaY), NSImage.CompositeCopy);
		
                            NSArray subviews = subviews();
                            final int n_subviews = subviews.count();
                            for (int i = 0;i < n_subviews;i++) {
                                NSView subview = (NSView)subviews.objectAtIndex(i);
                                NSRect subview_oldframe = subview.frame();
                                subview.setFrame(
                                    new NSRect(
                                        subview_oldframe.x(), subview_oldframe.y()+deltaY,
                                        subview_oldframe.width(), subview_oldframe.height()));
                            }
		
                            NSColor.clearColor().set();
                            NSGraphics.fillRectList(
                                new NSRect[] {new NSRect(0, 0, newframe.width(), deltaY)});

                            y = SHADOW_INTERVAL;
                        }
                    }
                    if (c != '\n') {
                        if (mainShadowColor != null) { // nullȂe𗎂ƂȂB
                            NSGraphics.drawAttributedString(
                                shadowstr, new NSPoint(x+SHADOW_INTERVAL, y-SHADOW_INTERVAL));
                        }
                        NSGraphics.drawAttributedString(astr, new NSPoint(x, y));
                        x += widthOfCurrentChar;
                    }

                    offscreen.unlockFocus();
                    if (redraw) {
                        setNeedsDisplay(true);
                    }
                    return null;
                }
            });
    }
    private void cleanUp() {
		// r[ƃItXN[̃TCYlɖ߂B
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    NSRect frame = superview().frame();
                    setFrame(frame);
                    setOffscreenSize(frame.size());
	
                    updateArrowsVisibilities();

                    offscreen.lockFocus();
                    NSColor.clearColor().set();
                    NSGraphics.fillRectList(new NSRect[] {frame()});
                    offscreen.unlockFocus();

                    for (Enumeration enu = subviews().objectEnumerator(); enu.hasMoreElements(); ) {
                        ((NSView)enu.nextElement()).removeFromSuperview();
                    }
	
                    resetLocation();
                    setNeedsDisplay(true);
                    return null;
                }
            });
    }

    public void redraw() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {

                    setNeedsDisplay(true);

                    return null;
                }
            });
    }

    public void addChar(char c) {
        drawChar(c, true);
    }
    public void addChar(char c, boolean redraw) {
		if (c < '\u0020') {
			throw new RuntimeException(
				"Adding control character is not allowed anymore. "+
				"Use methods like addReturn() instead.");
		}

        drawChar(c, redraw);
    }
    
    public void beEmpty() {
        cleanUp();
    }

    public void addReturn(final float ratio) {
        newline_ratio = ratio;
        drawChar('\n', true);
    }

    public void addView(final NSView view) {
        addSubviewAtCurrentLoc(view);
    }
    
    private void resetLocation() {
        // call this method only on the main thread
		x = 0;
		y = frame().height() - fontHeight;
    }

	private void setOffscreenSize(NSSize new_size) {
        // call this method only on the main thread
        
		// d offscreen.setSize(new_size) ƁA drawRect 
		//  composite ɃNbV₤c

		NSImage new_buffer = new NSImage(new_size);
        if (offscreen != null) {
            new_buffer.lockFocus();
            offscreen.compositeToPoint(NSPoint.ZeroPoint, NSImage.CompositeCopy);
            new_buffer.unlockFocus();
        }

		offscreen = new_buffer;
	}
}
