/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2007 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.apple.cocoa.foundation._private.*;

// ȉ̃y[W̃ACfBA؂肽B
// http://osdir.com/ml/macosx.devel/2003-05/msg00183.html

public class SCCommandManager {
    /* ̃NX͔Cӂ̃R[hubNCXbhśsA
     * ʂ󂯎ਂ̂̂łB
     */
    private static SCCommandManager _shared;
    private static SCCommandManager_Impl impl;
    private static NSObjectiveCSelector sel_callOnMainThread;
    private static NSSelector sel_callbackFromObjC;
    static {
        impl = new SCCommandManager_Impl(); // shared object
        sel_callOnMainThread = new NSObjectiveCSelector("tellObject:performSelectorOnMainThread:");
        sel_callbackFromObjC = new NSSelector("callbackFromObjC", new Class[] {});
    }

    public static SCCommandManager sharedManager() {
        if (_shared == null) {
            _shared = new SCCommandManager();
        }
        return _shared;
    }

    public Object exec(Command cmd) {

        if (SCFoundation.isHereMainThread()) {
            return cmd.run();
        }
        else {
            BoundCommand bound = new BoundCommand(cmd);
            return bound.callOnMainThread();
        }
    }

    public interface Command {
        // Object Ԃ̂ Runnable ͎gւȂB
        public Object run();
    }

    private class BoundCommand {
        private Object[] result;
        private Command  command;
        private boolean  returned;

        public BoundCommand(Command cmd) {
            result   = new Object[1];
            command  = cmd;
            returned = false;
        }

        public Object callOnMainThread() {
            try {
                sel_callOnMainThread.invoke(impl, new Object[] {this, sel_callbackFromObjC});
            }
            catch (Exception e) {
                throw new RuntimeException(e);
            }

            synchronized (result) {
                while (!returned) {
                    /* CXbhł̙|I͂܂ŃubN */
                    try {
                        result.wait();
                    }
                    catch (InterruptedException e) {}
                }
            }

            return result[0];
        }

        private void callbackFromObjC() {
            /* ͏ɃCXbh̒ */

            //System.out.println("+ " + command);
            
            synchronized (result) {
                result[0] = command.run();
                returned  = true;
                
                result.notifyAll();
            }

            //System.out.println("- " + command);
        }
    }
}