/*  $Id: SCCommunicateBoxController.java,v 1.4 2007/07/11 15:26:42 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2007 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCCommunicateBoxController extends NSWindowController {
    SCSession session;
    
    // IB Outlets
    NSTextField textfield;

    public static SCCommunicateBoxController newInstance(final SCSession session) {
        return (SCCommunicateBoxController)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCCommunicateBoxController(session);
                }
            });
    }
    
    private SCCommunicateBoxController(SCSession session) {
        // this constructor must only be called by the main thread
        super("CommunicateBox");
        this.session = session;
	
        window();
        window().setTitle("COMMUNICATE : "+session.getSelfName());
    }

    public void showWindow(final Object sender) {
        // \ׂʒuvZB
        // {̃VF̍COM{bNX̍킹邪A؂̖ʒu܂ł炵ďCB
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    final int screenWidth = (int)NSScreen.mainScreen().frame().width();
                    final int shellLeft   = (int)session.getShell(0).x();
                    final int shellTop    = (int)session.getShell(0).height();
                    
                    int comboxLeft   = shellLeft;
                    int comboxBottom = shellTop;
                    
                    if (comboxLeft < 0) {
                        comboxLeft = 0;
                    }
                    else if (comboxLeft + window().frame().width() > screenWidth) {
                        comboxLeft = screenWidth - (int)window().frame().width();
                    }
                    window().setFrameOrigin(new NSPoint(comboxLeft,comboxBottom));
	
                    SCCommunicateBoxController.super.showWindow(sender);
                    return null;
                }
            });
    }

    public void show() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {

                    if (!window().isVisible()) {
                        showWindow(null);
                    }
                    return null;
                }
            });
    }
    
    public void close(final Object sender) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    window().orderOut(null);
                    return null;
                }
            });
    }
    
    public void send(final Object sender) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (textfield.stringValue().length() > 0) {
                        session.doShioriCommunicateFromUser(textfield.stringValue());
                        textfield.setStringValue("");
                    }
                    return null;
                }
            });
    }
}
