/*  $Id: SCImageView.java,v 1.2 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2008 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCImageView extends NSView {
    NSImage img;
    int offset_x, offset_y;

    public static SCImageView newInstance(final NSImage img) {
        return (SCImageView)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCImageView(img);
                }
            });
    }
    private SCImageView(NSImage image) {
        super(new NSRect(NSPoint.ZeroPoint, image.size()));
        img = image;
        offset_x = offset_y = -1;
    }

    public static SCImageView newInstance(final NSImage img, final float width, final float height) {
        return (SCImageView)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCImageView(img, width, height);
                }
            });
    }
    private SCImageView(NSImage image, float width, float height) {
        // width܂height̒lł΁A`TCYgpB
        super(
            new NSRect(
                0,
                0,
                width < 0 ? image.size().width() : width,
                height < 0 ? image.size().height() : height));
        img = image;
        offset_x = width < 0 ? 0 : (int)((width - image.size().width()) / 2);
        offset_y = height < 0 ? 0 : (int)((height - image.size().height()) / 2);
    }

    public void drawRect(NSRect r) {
        img.compositeToPoint(
            new NSPoint(offset_x, offset_y),
            NSImage.CompositeSourceOver);
    }
}