/*  $Id: SCInputBoxController.java,v 1.5 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2007 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCInputBoxController extends NSWindowController {
    NSTextField textfield;
    
    SCInputBoxSession inputbox_session;
    SCSession session;

    public static SCInputBoxController newInstance(final SCInputBoxSession inputbox_session) {
        return (SCInputBoxController)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCInputBoxController(inputbox_session);
                }
            });
    }
    
    private SCInputBoxController(SCInputBoxSession inputbox_session) {
        super("InputBox");
        this.inputbox_session = inputbox_session;
        this.session = inputbox_session.getSession();
    
        window();
        window().setTitle("INPUT : "+session.getSelfName());
    }
    
    public void showWindow(final Object sender) {
        // \ׂʒuvZB
        // {̃VF̍INPUT{bNX̍킹邪A؂̖ʒu܂ł炵ďCB
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    final int screenWidth = (int)NSScreen.mainScreen().frame().width();
                    final int shellLeft   = (int)session.getShell(0).x();
                    final int shellTop    = (int)session.getShell(0).height();
                    
                    int teachboxLeft   = shellLeft;
                    int teachboxBottom = shellTop;
                    
                    if (teachboxLeft < 0) {
                        teachboxLeft = 0;
                    }
                    else if (teachboxLeft + window().frame().width() > screenWidth) {
                        teachboxLeft = screenWidth - (int)window().frame().width();
                    }
                    
                    window().setFrameOrigin(new NSPoint(teachboxLeft,teachboxBottom));
                    SCInputBoxController.super.showWindow(sender);

                    return null;
                }
            });
    }
    
    public void show() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {

                    if (!window().isVisible()) {
                        showWindow(null);
                    }
                    return null;
                }
            });
    }
    
    public void close(Object sender) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    window().orderOut(null);
                    return null;
                }
            });
    }
    
    public void send(Object sender) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (textfield.stringValue().length() > 0) {
                        inputbox_session.messageFromUser(textfield.stringValue());
                    }

                    return null;
                }
            });
    }
}
