/*  $Id: SCInputBoxSession.java,v 1.4 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2008 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

/*
    http://futaba.mikage.to/@uvpB
    
    
    phase 456


    \![open,inputbox,symbol,limittime] ŒP̓{bNX\B
    
    J{bNXɕ͂ enter ƁAOnUserInput Cxg
    Areference0  symbolAreference1 ɓ͂ꂽ񂪕ԂB
    ܂͂Ȃꍇł limittime Ŏ鎞Ԃo߂
    ͑҂ł؂ reference1 ɕ "timeout" ԂB
    limittime  -1 Zbgꍇ̓^CAEg͔ȂB
    limittime ̒Pʂ milli secondB

    ͑҂̊Ԃ passive [_ɂȂĂA񂪓͂
    ^CAEg܂Ń[U͑ɉłȂB

    Ꭶ

    \![open,inputbox,test,4000]
*/

public class SCInputBoxSession extends Thread {
    SCSession session;
    String symbol;
    int timeout;
    
    protected volatile boolean flagTerm = false;
    protected volatile String messageFromUser = null;
    SCInputBoxController box;
    
    public SCInputBoxSession(SCSession session,String symbol,int timeout) {
        this.session = session;
        this.symbol = symbol;
        this.timeout = timeout;
    }
    
    public void run() {
        final int pool = NSAutoreleasePool.push();
        
        // passivemodeɓAInputBoxJB
        session.setPassiveMode(true);
        box = SCInputBoxController.newInstance(this);
        box.show();
        
        // INPUTBOX̓͂ҋ@
        if (timeout == -1) { // ^CAEgȂ
            while (!flagTerm && messageFromUser == null) {
                try {
                    sleep(30 * 1000);
                }
                catch (InterruptedException e) {
                    if (flagTerm) break;
                    if (messageFromUser != null) break;
                }
            }
        }
        else {
            try {
                sleep(timeout);
            }
            catch (InterruptedException e) {}
        }
        
        if (!flagTerm) {
            if (messageFromUser == null) {
                // timed out
                session.doShioriEvent("OnUserInput",new String[] {symbol,"timeout"});
            }
            else {
                session.doShioriEvent("OnUserInput",new String[] {symbol,messageFromUser});
            }
        }
        
        box.close();
        session.setPassiveMode(false);
        NSAutoreleasePool.pop(pool);
    }
    
    public SCSession getSession() {
        return session;
    }
    
    public void messageFromUser(String msg) {
        messageFromUser = msg;
        interrupt();
    }
    
    public void terminate() {
        flagTerm = true;
        interrupt();
        if (box != null) box.close();

        try {
            join();
        }
        catch (InterruptedException e) {}
    }
}
