/*  $Id: SCInstallDialogController.java,v 1.3 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCInstallDialogController extends NSWindowController {
    private NSTextField messagefield;
    private NSTextField headfield;
    private NSButton closebutton;
    
    public SCInstallDialogController() {
        super("InstallDialog");
        window();
        
        headfield.setStringValue(SCStringsServer.getStrFromMainDic("installdialog.doing"));
        messagefield.setStringValue("");
    }
    
    public void show() {
        if (window().isVisible()) return;

        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    showWindow(null);
                    return null;
                }
            });
    }
    
    public void writeLine(String line) {
        messagefield.setStringValue( messagefield.stringValue() + line + "\n" );
    }
    
    public void failed() {
        headfield.setStringValue(SCStringsServer.getStrFromMainDic("installdialog.failed"));
        closebutton.setEnabled(true);
    }
    
    public void succeeded() {
        headfield.setStringValue(SCStringsServer.getStrFromMainDic("installdialog.succeeded"));
        closebutton.setEnabled(true);
    }
}
