/*  $Id: SCSafetyBalloonBackgroundView.java,v 1.7 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2008 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCSafetyBalloonBackgroundView extends NSView {
    double transparency; // 0Ȃ0ŗǂB
    NSImage bgimage;
    NSFont sstpMessageFont;
    NSColor sstpMessageColor;
    NSMutableAttributedString sstpmessage = null;
    NSPoint sstpMessageLoc;
    NSImage sstpMarkerImage;
    NSPoint sstpMarkerLoc;
    SCBalloonScrollArrow arrow_up,arrow_down;
    
    NSImage buffer;
    volatile boolean bufIsDirty = true;

    public SCSafetyBalloonBackgroundView(NSRect r) {
        // call this constructor only on the main thread
        super(r);
	
        buffer = new NSImage(r.size());
        sstpMessageFont = NSFont.systemFontOfSize(10.0f);
        sstpMessageColor = NSColor.grayColor();
        sstpMessageLoc = NSPoint.ZeroPoint;
    }

    public boolean isOpaque() {
        return false;
    }
    
    public void drawRect(NSRect r) {
        // call this method only on the main thread
        if (bufIsDirty) {
            buffer.lockFocus();
            redrawBuffer();
            buffer.unlockFocus();
	    
            bufIsDirty = false;
        }

        if (transparency == 0) {
            buffer.compositeToPointFromRect(r.origin(),r,NSImage.CompositeCopy);
        }
        else {
            buffer.dissolveToPointFromRect(r.origin(),r,(float)(1.0 - transparency));
        }
    }
    private void redrawBuffer() {
        // call this method only on the main thread
        NSColor.clearColor().set();
        NSGraphics.fillRectList(new NSRect[] {frame()});
	
        if (bgimage != null) {
            bgimage.compositeToPoint(NSPoint.ZeroPoint,NSImage.CompositeCopy);
        }
        else {
            NSColor.whiteColor().set();
            NSBezierPath.fillRect(frame());
        }
	
        if (sstpmessage != null) {
            if (sstpMarkerImage != null) {
                // At@`ltpnglB
                sstpMarkerImage.compositeToPoint(
                    sstpMarkerLoc, NSImage.CompositeSourceOver);
            }
	    
            NSGraphics.drawAttributedString(sstpmessage,sstpMessageLoc);
        }
    }
    
    public void setBGImage(NSImage img) {
        bgimage = img;
        redraw();
    }
    
    public void redraw() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    bufIsDirty = true;
                    setNeedsDisplay(true);
                    return null;
                }
            });
    }
    
    public void resizeWithOldSuperviewSize(NSSize s) {
        // call this method only on the main thread
        super.resizeWithOldSuperviewSize(s);
        buffer.setSize(frame().size());
        bufIsDirty = true;
        setNeedsDisplay(true);
    }
        
    public void setTransparency(double t) {
        transparency = t;
        redraw();
    }

    public final double getTransparency() {
        return transparency;
    }
    
    public float getSSTPMessageFontHeight() {
        return sstpMessageFont.ascender() - sstpMessageFont.descender();
    }
    
    public void setSSTPMessageColor(NSColor c) {
        sstpMessageColor = c;
        bufIsDirty = true;
    }
    
    public void setSSTPMessageLoc(NSPoint point) {
        sstpMessageLoc = point;
        bufIsDirty = true;
    }
    
    public void setSSTPMarkerImage(NSImage img) {
        sstpMarkerImage = img;
        bufIsDirty = true;
    }
    
    public void setSSTPMarkerLoc(NSPoint point) {
        sstpMarkerLoc = point;
        bufIsDirty = true;
    }
    
    public NSImage getSSTPMarkerImage() {
        return sstpMarkerImage;
    }
    
    public void setSSTPMessage(String str) {
        if (str == null || str.length() == 0) {
            sstpmessage = null;
        }
        else {
            sstpmessage = new NSMutableAttributedString(str);
            NSRange wholeStrRange = new NSRange(0,str.length());
            sstpmessage.addAttributeInRange(
                NSAttributedString.FontAttributeName,
                sstpMessageFont,
                wholeStrRange);
            sstpmessage.addAttributeInRange(
                NSAttributedString.ForegroundColorAttributeName,
                sstpMessageColor,
                wholeStrRange);
        }

        redraw();
    }
}
