/*  $Id: SCSafetyBalloonController.java,v 1.27 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2007 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.net.*;
import java.util.*;
import util.*;

public class SCSafetyBalloonController extends NSWindowController {
    boolean do_fade_out = true;
    int fade_out_step = 5;
    
    SCSession session;
    boolean atLeft = true; // trueȂVF̍ɂB
    
    int scope;
    int num; // ݂̃o[ԍB
    
    SCBalloonSkinServer bsserver;
    SCBalloonSkin skin; // ݂̃o[Bꂪnull̎̓v~eBuo[gpB
    
    SCSafetyBalloonBackgroundView bgview;
    
    NSScrollView textScrollView;
    SCBalloonTextView textview;
    SCBalloonScrollArrow arrow_up,arrow_down;
    
    SCScriptRunner callback_target_runner = null;
    
    Vector alternatives = null;
    boolean alternative_draw_underline;
    boolean alternative_draw_square;
    NSColor alternative_pen_color;
    NSColor alternative_brush_color;
    // null̂܂܂A̎̃tHgF̊eF
    // 1.0f̂pB
    NSColor alternative_font_color;
    
    Vector anchors = null;
    NSColor anchor_color;

    int default_window_level = NSWindow.NormalWindowLevel;

    public static SCSafetyBalloonController newInstance(final SCSession session, final int scope) {
        return (SCSafetyBalloonController)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCSafetyBalloonController(session, scope);
                }
            });
    }
    
    private SCSafetyBalloonController(SCSession session, int scope) {
        // SCSessionnullł邩mȂB
        // o[vr[ɂ͂łB
        super("SafetyBalloon");
        window().setAcceptsMouseMovedEvents(true);
        window().setDelegate(this);
        window().setAutodisplay(true);
        window().useOptimizedDrawing(false);
        textScrollView.setDrawsBackground(false);
	
        arrow_up   = SCBalloonScrollArrow.newInstance(this, SCBalloonSkinServer.ARROW_UP  );
        arrow_down = SCBalloonScrollArrow.newInstance(this, SCBalloonSkinServer.ARROW_DOWN);
        window().contentView().addSubview(arrow_up);
        window().contentView().addSubview(arrow_down);
        textview.initialize(arrow_up,arrow_down);
        textview.updateArrowsVisibilities();
	
        this.session = session;
        this.scope = scope;
	
        setType(0);
        setLevel(default_window_level);
    }
    
    public void close() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    SCSafetyBalloonController.super.close();
        
                    session  = null;
                    bsserver = null;
                    skin     = null;
        
                    textview.close();
        
                    arrow_up.cleanUp();   arrow_up   = null;
                    arrow_down.cleanUp(); arrow_down = null;
        
                    callback_target_runner = null;
        
                    if (alternatives != null) {
                        alternatives.clear();
                    }
        
                    if (anchors != null) {
                        anchors.clear();
                    }

                    return null;
                }
            });
    }

    public void setIgnoresMouseEvents(final boolean bool) {
        if (SCFoundation.BALLOON_USES_CLICK_THROUGH || bool == false) {
            
            SCCommandManager.sharedManager().exec(
                new SCCommandManager.Command() {
                    public Object run() {
                        
                        window().setIgnoresMouseEvents(bool);
                        return null;
                    }
                });
        }
    }

    public void scrollWheel(NSEvent event) {
        // this method must only be called by the AppKit
        scroll((float)Math.round(event.deltaY()));
    }
    
    public void scroll(final float deltaY) {
        SCCommandManager.sharedManager().exec(
                new SCCommandManager.Command() {
                    public Object run() {
                        
                        NSClipView clip = (NSClipView)textScrollView.contentView();
	
                        NSRect  oldrect  = clip.documentVisibleRect();
                        NSPoint oldpoint = oldrect.origin();
                        float old_x = oldpoint.x();
                        float old_y = oldpoint.y();
                        float max_vert_point = clip.documentRect().height() - oldrect.height();
	
                        float x = old_x;
                        float y = old_y + deltaY;
	
                        if (y < 0) y = 0;
                        else if (y > max_vert_point) y = max_vert_point;
	
                        clip.scrollToPoint(new NSPoint(x,y));
                        textview.updateArrowsVisibilities();

                        return null;
                    }
                });
    }
	
    public void mouseDown(NSEvent event) {
        // this method must only be called by the AppKit
        
        if (callback_target_runner != null) {
            // _uNbN(͂ȏ)H
            if (event.clickCount() >= 2) {
                callback_target_runner.terminate(); // ~
            }
            else {
                callback_target_runner.speedUp(); // Đxグ
            }
        }
    }
    
    public void mouseUp(NSEvent event) {
        // this method must only be called by the AppKit
        
        if (callback_target_runner != null) {
            callback_target_runner.speedDown(); // Đx
        }
    }
    
    // ngbLO@\B̃NXwindowdelegateɎw肳ĂB
    public void mouseMoved(NSEvent theEvent) {
        // this method must only be called by the AppKit
        
        if (!window().frame().containsPoint(NSEvent.mouseLocation(),false)) return;
	
        // {XNSViewNSWindow܂ŒH͂̃CxgX|_[`FC
        // ł͂킴킴tɓB
        if (alternatives != null) {
            final int n_alternatives = alternatives.size();
            for (int i = 0;i < n_alternatives;i++) {
                NSView alternative = (NSView)alternatives.elementAt(i);
		
                alternative.mouseMoved(theEvent);
            }
        }
        if (anchors != null) {
            final int n_anchors = anchors.size();
            for (int i = 0;i < n_anchors;i++) {
                NSView anchor = (NSView)anchors.elementAt(i);
		
                anchor.mouseMoved(theEvent);
            }
        }
    }
	
    public SCBalloonAlternative addAlternative(final String title, final String param) {
        if (alternatives == null) { // ꂪڂ̑I
            alternatives = new Vector();
        }
	
        // ǉ
        final SCBalloonAlternative alt = new SCBalloonAlternative(
            title,
            textview.getFont(),
            textview.getMainColor(),
            alternative_font_color,
            alternative_pen_color,
            alternative_brush_color,
            alternative_draw_underline,
            alternative_draw_square,
            true);
        
        alt.setAction(new NSSelector("alterAction", new Class[] {Object.class}));
        alt.setTarget(this);
        alt.setRefcon(param);
        alternatives.add(alt);
	
        textview.addView(alt);

        setIgnoresMouseEvents(false);

        return alt;
    }
	
    public void addAnchor(String title,String id) {
        if (anchors == null)
            anchors = new Vector();
	
        final SCBalloonAlternative anc = new SCBalloonAlternative(
            title,
            textview.getFont(),
            anchor_color,
            anchor_color,
            anchor_color,
            anchor_color,
            true,
            false,
            false);
        
        anc.setAction(new NSSelector("anchorAction", new Class[] {Object.class}));
        anc.setTarget(this);
        anc.setRefcon(id);
        anchors.add(anc);
	
        textview.addView(anc);

        setIgnoresMouseEvents(false);
    }

    public void setCallbackTarget(SCScriptRunner runner) {
        // IAJ[NbNꂽɃR[obNsXNvgi[ݒ肷B
        callback_target_runner = runner;
    }
    
    public void alterAction(Object sender) {
        // ̃\bh͒ڌĂяoĂ͂Ȃ܂B
        // IActionƂăR[܂B
        callback_target_runner.alternativeSelected((SCBalloonAlternative)sender);
    }
    
    public void anchorAction(Object sender) {
        callback_target_runner.anchorSelected((SCBalloonAlternative)sender);
    }
    
    private void removeAllAlternatives() {
        if (alternatives == null) return;

        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
	
                    int n_alts = alternatives.size();
                    for (int i = 0;i < n_alts;i++) {
                        SCBalloonAlternative alt = (SCBalloonAlternative)alternatives.elementAt(i);
                        alt.removeFromSuperview();
                    }

                    return null;
                }
            });
	
        alternatives = null;
    }
    
    private void removeAllAnchors() {
        if (anchors == null) return;

        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
	
                    int n_ancs = anchors.size();
                    for (int i = 0;i < n_ancs;i++) {
                        SCBalloonAlternative anc = (SCBalloonAlternative)anchors.elementAt(i);
                        anc.removeFromSuperview();
                    }

                    return null;
                }
            });
	
        anchors = null;
    }

    public void addImage(final String name, final int x, final int y) {
        // FIXME: 摜𒼐ڕ`subviewɂǂBŁB
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
	
                    //System.out.println("adding balloon image to [" + x + "," + y + "]");
                    String dir = session.getGhostMasterDirPath();
                    File f = new File(dir, name);
                    NSImage img = new NSImage(f.getPath(),true);
                    //System.out.println("file name is " + f.getPath());
                    //System.out.println("file object is " + img.toString());
                    NSPoint p = new NSPoint(x, y);
                    textview.drawImage(img, p);

                    return null;
                }
            });
    }

    public void addSstpMarkerAsText() {
	
        show();
	
        NSImage marker = bsserver.getSstpMarkerImage();
        if (marker == null) {
            // 摜Ȃ當łoB
            textview.addChar('*');
        }
        else {
            SCImageView img = SCImageView.newInstance(marker, -1, textview.getFontHeight());
            textview.addView(img);
        }
    }
    
    public void setType(final int newBalloonNum) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    num = newBalloonNum;
                    if (bsserver == null) return null;
	
                    // ɂ΍pɁAEɂΉEpɁAꂼꐔlCB
                    if (atLeft) {
                        num = (num % 2 == 0 ? num : num-1);
                    }
                    else {
                        num = (num % 2 == 0 ? num+1 : num);
                    }
	
                    skin = bsserver.findSkin(num, scope);
                    if (skin != null) {
                        NSImage background = skin.getImage();
                        window().setContentSize(background.size());
                        setBalloonAttributesFromDescription();
                        window().setHasShadow(false);
                        bgview.setBGImage(background);
                        textview.changedSize();
                        textview.setNeedsDisplay(true);
                    }
                    else {
                        bgview.setBGImage(null);
                        window().setHasShadow(true);
	    
                        NSSize newSize;
                        if (scope == 0) {
                            if (num == 0 || num == 1) {
                                newSize = new NSSize(326, 169);
                            }
                            else {
                                newSize = new NSSize(326, 384);
                            }
                        }
                        else {
                            newSize = new NSSize(326, 96);
                        }
                        window().setContentSize(newSize);
                        setBalloonAttributesFromDescription();
                        bgview.redraw();
                        textview.changedSize();
                        textview.setNeedsDisplay(true);
                    }

                    return null;
                }
            });
    }
    
    public void setBalloonServer(SCBalloonSkinServer bsserver) {
        this.bsserver = bsserver;
        setType(num); // [h
    }
    
    public final void setTransparency(final double t) {
        bgview.setTransparency(t);
    }

    public final double getTransparency() {
        return bgview.getTransparency();
    }
    
    public final void setDoesFadeOut(boolean b) {
        do_fade_out = b;
    }

    public final boolean getDoesFadeOut() {
        return do_fade_out;
    }
    
    public void beEmpty() {
        textview.beEmpty();
        setIgnoresMouseEvents(true);
    }
    
    public void makeSSTPMsgEmpty() {
        bgview.setSSTPMessage("");
        bgview.redraw();
    }
    
    public void addText(String text, long wait) throws InterruptedException {
        // wait~b̃EGCgtextꕶǉ܂B
        // EGCĝŃCXbhĂяo肵ȂŉB
        // ܂Ã\bhĂяoXbhɃC^vgꍇ́A𒆎~܂B
        int n_chars = text.length();

        for (int i = 0; i < n_chars; i++) {
            textview.addChar(text.charAt(i), wait > 0);

            if (wait > 0) {
                Thread.sleep(wait);
            }
        }

        if (wait == 0) {
            textview.redraw();
        }
    }
    
    public void addChar(char c) {
        textview.addChar(c);
    }

    public void addReturn() {
        textview.addReturn(1.0f);
    }

    public void addReturn(float ratio) {
        textview.addReturn(ratio);
    }
    
    public void showSSTPMessage(String msg) {
        bgview.setSSTPMessage(msg);
        bgview.redraw();
    }
    
    public void setLoc(final NSPoint loc) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    window().setFrameTopLeftPoint(loc);
                    checkWentOut();

                    return null;
                }
            });
    }
    
    public void setOrigin(final NSPoint loc) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    window().setFrameOrigin(loc);
                    checkWentOut();

                    return null;
                }
            });
    }
    
    public void checkWentOut() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    // o[؂ĂΔΑɂ܂킷B
                    // AΑɂ܂킵Ă؂Ă΁A؂̓xȂقIԁB
                    if (session != null) {
                        final int screenWidth = (int)NSScreen.mainScreen().frame().width();

                        // ؂Ăΐ̒lB
                        int left_mikire_width = -1 *
                            session.simulateHorizLoc(scope, true);
                        // ؂Ăΐ̒lB
                        int right_mikire_width = -1 *
                            (screenWidth -
                             (session.simulateHorizLoc(scope, false) +
                              (int)width()));
                        
                        if (x() < 0) {
                            if (right_mikire_width <= 0 || left_mikire_width > right_mikire_width) {
                                setToRight();
                            }
                        }
                        else if (x() + width() > screenWidth) {
                            if (left_mikire_width <= 0 || left_mikire_width < right_mikire_width) {
                                setToLeft();
                            }
                        }
                    }

                    return null;
                }
            });
    }
    
    private void setToLeft() {
        if (atLeft) {
            return;
        }
	
        atLeft = true;
        setType((num % 2 == 1 ? num-1 : num));
	
        if (session != null) {
            session.recalcBalloonsLoc();
        }
    }
    
    private void setToRight() {
        if (!atLeft) {
            return;
        }
	
        atLeft = false;
        setType((num % 2 == 0 ? num+1 : num));
	
        if (session != null) {
            session.recalcBalloonsLoc();
        }
    }
    
    public boolean isAtLeft() {
        return atLeft;
    }

    public NSRect frame() {
        return (NSRect)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return window().frame();
                }
            });
    }
    
    public float width() {
        return frame().width();
    }
    
    public float height() {
        return frame().height();
    }
    
    public float x() {
        return frame().x();
    }
    
    public float y() {
        return frame().y();
    }

    public void setLocation(int x, int y) {
        textview.setLocation(x, y);
    }
    
    public NSSize size() {
        return frame().size();
    }
    
    public void show() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (SCFoundation.LOCK_BALLOONS) return null;
                    if (window().isVisible()) return null;
	
                    showWindow(null);

                    return null;
                }
            });
    }
    
    public void hide() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (!window().isVisible()) return null;
	
                    if (do_fade_out) {
                        for (int i = fade_out_step-1; i >= 1; i--) {
                            window().setAlphaValue((float)i / (float)fade_out_step);
                        }
                        window().orderOut(null);
                        window().setAlphaValue(1.0f);
                    }
                    else {
                        window().orderOut(null);
                    }
	
                    cleanUp();
                    return null;
                }
            });
    }            
    
    public void cleanUp() {
        removeAllAlternatives();
        removeAllAnchors();
        beEmpty();
        bgview.redraw();
        callback_target_runner = null; // ͂svȂ̂ŎQƂB
    }

    public NSScrollView getTextScrollView() {
        return textScrollView;
    }
    
    public void setLevel(final int level) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    default_window_level = level;
                    window().setLevel(level);

                    return null;
                }
            });
    }

    public int getLevel() {
        return default_window_level;
    }

    public void activateTemporarily() {
        if (default_window_level == NSWindow.NormalWindowLevel) {

            SCCommandManager.sharedManager().exec(
                new SCCommandManager.Command() {
                    public Object run() {
                    
                        window().setLevel(NSWindow.ModalPanelWindowLevel);
                        return null;
                    }
                });
        }
    }

    public void deactivate() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (default_window_level != window().level()) {
                        window().setLevel(default_window_level);

                        if (window().isVisible()) {
                            window().orderFront(this);
                        }
                    }

                    return null;
                }
            });
    }
    
    public void requestChangeFont(NSFont newfont) {
        textview.setFont(newfont);
    }

    public final NSFont getFont() {
        return textview.getFont();
    }
    
    public void setFontColor(NSColor color) {
        textview.setMainColor(color);
    }
    
    public void setShadowColor(NSColor color) {
        textview.setMainShadowColor(color);
    }
    
    public void setSSTPMessageColor(NSColor color) {
        bgview.setSSTPMessageColor(color);
    }
    
    public void setSSTPMessageLoc(NSPoint point) {
        bgview.setSSTPMessageLoc(point);
    }
    
    public void setSSTPMarkerLoc(NSPoint point) {
        bgview.setSSTPMarkerLoc(point);
    }
    
    public void setSSTPMarkerImage(NSImage img) {
        bgview.setSSTPMarkerImage(img);
    }
    
    public float getSSTPMessageFontHeight() {
        return bgview.getSSTPMessageFontHeight();
    }

    public SCSafetyBalloonBackgroundView getBGView() {
        return bgview;
    }
    
    private void setBalloonAttributesFromDescription() {
        // this method must be called only by the main thread
        
        float r,g,b;
        // ̂o[XLȂ炻̑ǂݍށB
        SCDescription desc = (skin == null ? bsserver.getDescription() : skin.getDescription());
	
        // originwordwrappoint擾AtextScrollVieẅʒuƃTCY
        int origin_x,origin_y; // tWnł̍W
        if (desc.exists("origin.x")) {
            origin_x = desc.getIntValue("origin.x");
            origin_y = desc.getIntValue("origin.y");
        }
        else {
            origin_x = origin_y = 10;
        }
        if (origin_x < 0) origin_x = 0;
        if (origin_y < 0) origin_y = 0;
        int tvWidth,tvHeight;
        if (desc.exists("wordwrappoint.x")) {
            int wwp_x = desc.getIntValue("wordwrappoint.x");
            tvWidth = (wwp_x > 0 ? wwp_x - origin_x : (int)width() + wwp_x - origin_x);
        }
        else {
            tvWidth = (int)width() - 2 - SCBalloonScrollArrow.DEFAULT_WIDTH - 2 - origin_x;
        }
        if (tvWidth < 0) tvWidth = 0;
        if (origin_x + tvWidth > width()) tvWidth = (int)width() - origin_x - 1;
        if (desc.exists("validrect.bottom")) {
            int vr_b = desc.getIntValue("validrect.bottom");
            if (vr_b > (int)height()) vr_b = (int)height();
            tvHeight = (vr_b > 0 ? vr_b - origin_y : (int)height() + vr_b - origin_y);
        }
        else {
            tvHeight = (int)height() - 15 - origin_y;
        }
        if (tvHeight < 0) tvHeight = 0;
        if (origin_y + tvHeight > height()) tvHeight = (int)height() - origin_y - 1;
        textScrollView.setFrame(new NSRect(origin_x,height() - origin_y - tvHeight,tvWidth,tvHeight));
	
        // tHg̐F
        r = desc.getIntValue("font.color.r") / 255.0f;
        g = desc.getIntValue("font.color.g") / 255.0f;
        b = desc.getIntValue("font.color.b") / 255.0f;
        setFontColor(NSColor.colorWithCalibratedRGB(r,g,b,1.0f));
	
        // e̐F
        if (desc.exists("font.shadowcolor.r")) {
            if (desc.getIntValue("font.shadowcolor.r") == -1) {
                // e 
                setShadowColor(null);
            }
            else {
                r = desc.getIntValue("font.shadowcolor.r") / 255.0f;
                g = desc.getIntValue("font.shadowcolor.g") / 255.0f;
                b = desc.getIntValue("font.shadowcolor.b") / 255.0f;
                setShadowColor(NSColor.colorWithCalibratedRGB(r,g,b,1.0f));
            }
        }
        else {
            // setShadowColor(NSColor.colorWithCalibratedWhite(0.0f,0.3f));
            setShadowColor(null);
        }
	
        // SSTPbZ[W̐F
        if (!desc.exists("sstpmessagecolor.r")) {
            r = g = b = 0.5f;
        }
        else {
            r = desc.getIntValue("sstpmessagecolor.r") / 255.0f;
            g = desc.getIntValue("sstpmessagecolor.g") / 255.0f;
            b = desc.getIntValue("sstpmessagecolor.b") / 255.0f;
        }
        setSSTPMessageColor(NSColor.colorWithCalibratedRGB(r,g,b,1.0f));
	
        // SSTPbZ[Wʒu
        if (desc.exists("sstpmessage.x")) {
            int horiz = desc.getIntValue("sstpmessage.x");
            int vert = desc.getIntValue("sstpmessage.y");
	    
            setSSTPMessageLoc(new NSPoint(horiz,(vert > 0 ? height() - vert : -1 * vert) - (int)getSSTPMessageFontHeight()));
        }
        else {
            setSSTPMessageLoc(new NSPoint(2,2));
        }
	
        // SSTP}[J[摜ƈʒu
        NSImage marker = bsserver.getSstpMarkerImage();
        setSSTPMarkerImage(marker);
        if (marker != null) {
            if (desc.exists("sstpmarker.x")) {
                int horiz = desc.getIntValue("sstpmarker.x");
                int vert = desc.getIntValue("sstpmarker.y");
		
                setSSTPMarkerLoc(new NSPoint(horiz,(vert > 0 ? height() - vert : -1 * vert) - (int)marker.size().height()));
            }
            else {
                setSSTPMarkerLoc(new NSPoint(2,2));
            }
        }
	
        // I
        if (!desc.exists("cursor.style")) {
            alternative_draw_underline = alternative_draw_square = true;
        }
        else {
            String style_str = desc.getStrValue("cursor.style");
            if (style_str.equals("square")) {
                alternative_draw_square = true;
            }
            else if (style_str.equals("underline")) {
                alternative_draw_underline = true;
                alternative_draw_square = false;
            }
            else if (style_str.equals("square+underline")) {
                alternative_draw_underline = alternative_draw_square = true;
            }
        }
	
        if (!desc.exists("cursor.pen.color.r")) {
            r = g = b = 10.0f / 255.0f;
        }
        else {
            r = desc.getIntValue("cursor.pen.color.r") / 255.0f;
            g = desc.getIntValue("cursor.pen.color.g") / 255.0f;
            b = desc.getIntValue("cursor.pen.color.b") / 255.0f;
        }
        alternative_pen_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
	
        if (!desc.exists("cursor.brush.color.r")) {
            r = g = b = 0.5f;
        }
        else {
            r = desc.getIntValue("cursor.brush.color.r") / 255.0f;
            g = desc.getIntValue("cursor.brush.color.g") / 255.0f;
            b = desc.getIntValue("cursor.brush.color.b") / 255.0f;
        }
        alternative_brush_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
	
        alternative_font_color = null;
        if (desc.exists("cursor.font.color.r")) {
            String blendmethod = desc.getStrValue("cursor.blendmethod");
            if ((blendmethod != null && blendmethod.equals("none")) || blendmethod == null) {
                r = desc.getIntValue("cursor.font.color.r") / 255.0f;
                g = desc.getIntValue("cursor.font.color.g") / 255.0f;
                b = desc.getIntValue("cursor.font.color.b") / 255.0f;
		
                alternative_font_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
            }
        }
	
        // XN[A[
        NSImage image_arrow_up = bsserver.getArrowImage(SCBalloonSkinServer.ARROW_UP);
        NSImage image_arrow_down = bsserver.getArrowImage(SCBalloonSkinServer.ARROW_DOWN);
        //Logger.log(this, Logger.DEBUG, "arrow up: {"+image_arrow_up+"}");
        arrow_up.setImage(image_arrow_up);
        arrow_down.setImage(image_arrow_down);
        float x,y;
        if (!desc.exists("arrow0.x")) {
            x = width() - 2 - arrow_up.width();
            y = height() - 2 - arrow_up.height();
        }
        else {
            x = desc.getIntValue("arrow0.x");
            y = desc.getIntValue("arrow0.y");
            if (x < 0) x = width() + x;
            if (y < 0)
                y = -1*y - arrow_up.height();
            else
                y = height() - y - arrow_up.height();
        }
        arrow_up.setFrameOrigin(x,y);
        //Logger.log(this, Logger.DEBUG, "width: "+width()+"; arrow_up: {"+arrow_up+"}");
	
        if (!desc.exists("arrow1.x")) {
            x = width() - 2 - arrow_down.width();
            y = 2;
        }
        else {
            x = desc.getIntValue("arrow1.x");
            y = desc.getIntValue("arrow1.y");
            if (x < 0) x = width() + x;
            if (y < 0)
                y = -1*y - arrow_down.height();
            else
                y = height() - y - arrow_down.height();
        }
        arrow_down.setFrameOrigin(x,y);
	
        // AJ[
        if (!desc.exists("anchor.font.color.r")) {
            r = b = 0.0f;
            g = 0.8f;
        }
        else {
            r = desc.getIntValue("anchor.font.color.r") / 255.0f;
            g = desc.getIntValue("anchor.font.color.g") / 255.0f;
            b = desc.getIntValue("anchor.font.color.b") / 255.0f;
        }
        anchor_color = NSColor.colorWithCalibratedRGB(r,g,b,1.0f);
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("session: {").append(session).append('}');
        buf.append("; scope: ").append(scope);
        buf.append("; skin id: ").append(num);
        if (skin != null) {
            buf.append("; skin: {").append(skin).append('}');
        }
        return buf.toString();
    }

    public final int getScope() {
        return scope;
    }

    public SCBalloonSkin getSkin() {
        return skin;
    }

    public String getSkinOpt(String key) {
        if (skin == null) {
            return null;
        }
        return skin.getDescription().getStrValue(key);
    }

    protected void finalize() {
        Logger.log(this, Logger.DEBUG, "finalized");
    }
}
