/*  $Id: SCSeriko.java,v 1.9 2007/07/11 15:26:42 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
  SCSeriko
    
  SERIKȎSĂ̓̊Ǘs܂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import util.*;

public class SCSeriko {
    private SCSerikoLibrary seriko_lib;
    private Hashtable current_group; // (Integer)scope => group(SCSerikoSeqGroup)
    private SCSerikoBindCenter bindCenter;
    private Vector runners; // SCSerikoSequenceRunner

     // option[exclusive]̃V[PX쒆̎ trueB
    private volatile boolean exclusive_locked = false;

    // Seriko ~Ȃ trueB̃tB[h͕K runners ɑ΂
    // synchronized ubN椂ݏȂ΂ȂȂB
    boolean isStopped;
    
    SCSession session;
    SCShell shell;
    
    public SCSeriko(SCSession session,SCShell shell,File shelldir) {
        this.session = session;
        this.shell = shell;
	
        seriko_lib    = new SCSerikoLibrary(shell);
        current_group = new Hashtable();
        runners       = new Vector();
        bindCenter    = new SCSerikoBindCenter(session,shell,this);

        isStopped     = false;
    }
    
    public void dumpLibrary() {
        seriko_lib.dump();
    }

    public void stop(int scope) {
        // ꎞ~B

        synchronized (runners) {
            isStopped = true;

            terminateAllRunnersThread(scope);
        }
    }

    public void restart(int scope) {
        // ĊJB

        SCSerikoSeqGroup group = getCurrentSeqGroup(scope);
        if (group == null) {
            return;
        }

        synchronized (runners) {
            isStopped = false;

            execute(group.makeSequenceArray("runonce"), scope);
            execute(group.makeSequenceArray("always"), scope);
            execute(group.makeSequenceArray("random"), scope);
        }
    }

    public SCSerikoSeqGroup getCurrentSeqGroup(int scope) {
        return (SCSerikoSeqGroup)current_group.get(new Integer(scope));
    }
    
    public void surfaceChanged(int new_id, int scope) {
        // T[tBXςꂽɌĂ΂܂B
        // ܂ł̃Aj[VN[AbvAVȃV[PXO[v̏펞NnGgN܂B
        // T[tBXIDƃV[PXO[vID́ARłB
	
        // N[Abv
        stop(scope);
        bindCenter.disableAll();
	
        // JgO[vύX
        SCSerikoSeqGroup new_group = seriko_lib.findSeqGroup(new_id);
        if (new_group == null) {
            current_group.remove(new Integer(scope));
        }
        else {
            current_group.put(new Integer(scope), new_group);
        }

        restart(scope);
        bindCenter.enableCheckedBindGroups();
    }
    
    public void execute(Vector sequences, int scope) {
        int n_sequences = sequences.size();
        for (int i = 0;i < n_sequences;i++) {
            SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
            execute(seq.id(), scope);
        }
    }
    
    public void execute(int seqid, int scope) {
        // ݂̃O[v̎w肳ꂽV[PX𑖂点܂B
        // V[PX^Cvbindꍇł삵܂B
        if (SCFoundation.STOP_SERIKO) return;
	
        SCSerikoSeqGroup group = getCurrentSeqGroup(scope);
        if (group == null) return;
        SCSerikoSequence seq = group.findSequence(seqid);
        if (seq == null) return;

        SCSerikoSequenceRunner runner = new SCSerikoSequenceRunner(
            this, shell, seq, scope, session);

        // ɏIĂ郉i[̓Xg폜B
        synchronized (runners) {
            for (Iterator ite = runners.iterator(); ite.hasNext(); ) {
                SCSerikoSequenceRunner current = (SCSerikoSequenceRunner)ite.next();

                if (!current.isAlive()) {
                    ite.remove();
                }
            }

            if (!isStopped) {
                runners.add(runner);
                runner.start();
            }
        }
    }
    
    public void terminateAllRunnersOverlay() {
        synchronized (runners) {
            int n_runners = runners.size();
            for (int i = 0;i < n_runners;i++) {
                SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
                runner.terminateOverlay();
            }
        }
    }
    
    public void terminateAllRunnersOverlay(int scope) {
        synchronized (runners) {
            int n_runners = runners.size();
            for (int i = 0;i < n_runners;i++) {
                SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
                if (runner.getScope() == scope) {
                    runner.terminateOverlay();
                }
            }
        }
    }

    public void interruptAllRunners(int scope) {
        synchronized (runners) {
            int n_runners = runners.size();
            for (int i = 0;i < n_runners;i++) {
                SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
                if (runner.getScope() == scope) {
                    runner.interrupt();
                }
            }
        }
    }
    
    public void terminateAllRunnersThread() {
        synchronized (runners) {
            int n_runners = runners.size();
            for (int i = 0;i < n_runners;i++) {
                SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
                runner.terminateThread();
            }
        }
    }
    
    public void terminateAllRunnersThread(int scope) {
        synchronized (runners) {
            int n_runners = runners.size();
            for (int i = 0;i < n_runners;i++) {
                SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
                if (runner.getScope() == scope) {
                    runner.terminateThread();
                }
            }
        }
    }
    
    public void terminateTargetRunner(int target_id, int scope) {
        synchronized (runners) {
            int n_runners = runners.size();
            for (int i = 0;i < n_runners;i++) {
                SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
                if (runner.getSeqID() == target_id && runner.getScope() == scope) {
                    runner.terminateThread();
                }
            }
        }
    }
    
    public void setExclusiveLocked(boolean b) {
        exclusive_locked = b;
    }
    
    public boolean isExclusiveLocked() {
        return exclusive_locked;
    }
    
    public void terminate() {
        // SERIKOI܂B
        synchronized (runners) {
            isStopped = true;

            seriko_lib = null;
            current_group = null;
            bindCenter.terminate(); bindCenter = null;
	
            terminateAllRunnersOverlay();
            terminateAllRunnersThread();
            runners.clear();

            session = null;
            shell = null;
        }
    }
    
    public SCSerikoBindCenter getBindCenter() {
        // ւj[݂ȂnullB
        return bindCenter;
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("session: {").append(session).append('}');
        buf.append("; shell: {").append(shell).append('}');
        if (runners.size() > 0) {
            buf.append("; runners: [");
            for (Iterator ite = runners.iterator(); ite.hasNext(); ) {
                buf.append('{').append(ite.next()).append('}');
                if (ite.hasNext()) {
                    buf.append(", ");
                }
            }
            buf.append(']');
        }
        if (exclusive_locked) {
            buf.append("; exclusive locked");
        }
        return buf.toString();
    }

    protected void finalize() {
        //Logger.log(this, Logger.DEBUG, "finalized");
    }
}
