/*  $Id: SCShellWindowController.java,v 1.13 2007/07/11 15:26:42 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2007 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import util.*;

public class SCShellWindowController extends NSWindowController {
    SCShellView view;
    
    SCSession session;
    SCSurface surface = null;
    SCSurface basesurface = null; // changeSurfaceł͕ω邪tempChangeBaseł͕ωȂB
    double ratio = 1.0;
    float baseHorizLoc; // SERIKOmoveœȂAhbOŌ肳ꂽʒuB
    int scope;
    int default_window_level = NSWindow.NormalWindowLevel;

    public static SCShellWindowController newInstance(final SCSession s, final int scope) {
        return (SCShellWindowController)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCShellWindowController(s, scope);
                }
            });
    }
    
    private SCShellWindowController(SCSession s, int scope) {
        // call this constructor only on the main thread
        super("ShellWindow");
        window();
    
        session = s;
        this.scope = scope;
    
        window().setFrameOrigin( new NSPoint( x() , 0 ) );
        window().setAutodisplay(true);
    
        ((SCShellWindow)window()).initialize(s, this);
        view.initialize(this);

        setLevel(default_window_level);
    }
    
    public void changeSurface(final SCSurfaceServer sserver, final int id) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    // id-1ł\B
                    if (id == -1) {
                        // \̈̃TCY͑Ô̂㋂B
                        view.changeSurface(null);
                        basesurface = surface = null;
                    }
                    else {
                        basesurface
                            = surface
                            = sserver.findSurface(id, scope);
                        if (surface == null) return null;
            
                        NSImage image = surface.getImage();
                        if (image == null) return null;

                        // WbaseHorizLocgp鎖ŁAoffset𖳎B
                        NSRect newrect = new NSRect(
                            baseHorizLoc, 0,
                            image.size().width(), image.size().height());

                        window().setFrame(newrect,false);
                        view.changeSurface(image);
                    }
        
                    view.display();
                    session.recalcBalloonsLoc();
                    window().setHasShadow(false);

                    return null;
                }
            });
    }
    
    public void tempChangeBase(final SCSurfaceServer sserver, final int id) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    // SERIKObase\bhŎg܂B
                    // x[XT[tBX񂪕ς炸ɁAꎞIɃx[XT[tBXւ܂B
                    surface = sserver.findSurface(id, scope);
                    if (surface == null) return null;
        
                    NSImage image = surface.getImage();
                    if (image == null) return null;
        
                    NSRect newrect = new NSRect(window().frame().origin(),image.size());
        
                    window().setFrame(newrect,false);
                    view.changeSurface(image);
        
                    view.display();
                    session.recalcBalloonsLoc();
                    window().setHasShadow(false);
                    
                    return null;
                }
            });
    }
    
    public void reloadSurface(SCSurfaceServer sserver) {
        changeSurface(sserver, surface.getID());
    }
    
    public void surfaceResized(SCSurfaceServer sserver,double r) {
        // TCYꂽɌĂłB
        ratio = r;
        if (surface != null) changeSurface(sserver, surface.getID());
    }
    
    public void setLevel(final int level) {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    default_window_level = level;
                    window().setLevel(level);

                    return null;
                }
            });
    }

    public final int getLevel() {
        return default_window_level;
    }

    public void activateTemporarily() {
        if (default_window_level == NSWindow.NormalWindowLevel) {
            SCCommandManager.sharedManager().exec(
                new SCCommandManager.Command() {
                    public Object run() {
                        
                        window().setLevel(NSWindow.ModalPanelWindowLevel);
                        return null;
                    }
                });
        }
    }

    public void deactivate() {
        SCCommandManager.sharedManager().exec(
                new SCCommandManager.Command() {
                    public Object run() {
                        
                        if (default_window_level != window().level()) {
                            window().setLevel(default_window_level);
        
                            if (window().isVisible()) {
                                window().orderFront(this);
                            }
                        }

                        return null;
                    }
                });
    }
    
    public void show() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {

                    if (window().isVisible()) {
                        return null;
                    }

                    showWindow(null);

                    // mredraw
                    window().setViewsNeedDisplay(true);

                    return null;
                }
            });
    }
    
    public void hide() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    if (!window().isVisible()) {
                        return null;
                    }

                    window().orderOut(null);
                    basesurface = surface = null;

                    return null;
                }
            });

        // SERIKÕXbh~߂B
        session.getCurrentShell().getSeriko().stop(scope);
    }
    
    public void close() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    SCShellWindowController.super.close();
    
                    view.cleanUp();
                    view = null;
                    session = null;
                    surface = null;
                    basesurface = null;

                    return null;
                }
            });
    }
    
    public NSRect frame() {
        return (NSRect)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return window().frame();
                }
            });
    }
    
    public float width() {
        return frame().width();
    }
    
    public float height() {
        return frame().height();
    }
    
    public float x() {
        return frame().x();
    }
    
    public float y() {
        return frame().y();
    }
    
    public void setHorizLoc(final float x) {
        // xWݒ肵܂B
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    baseHorizLoc = x;
                    window().setFrameOrigin( new NSPoint( x , y() ) );

                    return null;
                }
            });
    }
    
    public void absoluteSetLoc(final float x, final float y) {
        // w肳ꂽƂx,yWݒ肵܂B
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    baseHorizLoc = x;
                    window().setFrameOrigin( new NSPoint(x,y) );

                    return null;
                }
            });
    }
    
    public void setOffset(final float x, final float y) {
        // SERIKO movepB
        // moveɖ֌WɌ肳ꂽʒu̍ōWύX܂B
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                     // ỹx[X͏Ƀ[B
                    window().setFrameOrigin( new NSPoint(baseHorizLoc + x, y) );

                    return null;
                }
            });
    }
    
    public void setViewsNeedDisplay(boolean bool) {
        // NSWindow#setViewsNeedDisplay()̂@\Ȃ̂ŎŎB
        // ƂĂsōςł܂B
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    // FIXME: CXbhĂԂ₤ɂ̂ŕ
                    //  NSWindow#setViewsNeedDisplay() gւ邩m
                    // ȂB
                    window().contentView().setNeedsDisplay(true);

                    return null;
                }
            });
    }
    
    public int currentSurfaceId() {
        return (surface == null ? -1 : surface.getID());
    }
    
    public SCSurface currentSurface() {
        return surface;
    }
    
    public int baseSurfaceId() {
        return (basesurface == null ? -1 : basesurface.getID());
    }
    
    public SCSurface baseSurface() {
        return basesurface;
    }
    
    public void setBalloon(SCSafetyBalloonController balloon) {
        ((SCShellWindow)window()).setBalloon(balloon);
    }
    
    public double getRatio() {
        return ratio;
    }

    public NSPoint convertScreenToBase(final NSPoint screenLoc) {
        return (NSPoint)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return window().convertScreenToBase(screenLoc);
                }
            });
    }
    
    public SCShellView getView() {
        return view;
    }
    
    public int getScope() {
        return scope;
    }
    
    public SCSession session() {
        return session;
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("session: {").append(session).append('}');
        buf.append("; ratio: ").append(ratio);
        buf.append("; scope: ").append(scope);
        return buf.toString();
    }

    protected void finalize() {
        Logger.log(this, Logger.DEBUG, "finalized");
    }
}
