/*  $Id: SCVanishWindowController.java,v 1.3 2007/07/11 15:26:42 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2007 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCVanishWindowController extends NSWindowController {
    SCSession session;
    
    NSTextField msgTextField;

    public static SCVanishWindowController newInstance(final SCSession session) {
        return (SCVanishWindowController)SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    return new SCVanishWindowController(session);
                }
            });
    }
    
    private SCVanishWindowController(SCSession session) {
        // this constructor must only be called by the main thread
        super("Vanish");
        this.session = session;
        window();
		
        window().setTitle(
            SCStringsServer.getStrFromMainDic(
                "vanishdialog.title",
                new String[] { session.getSelfName() }));
        
        msgTextField.setStringValue(
            SCStringsServer.getStrFromMainDic(
                "vanishdialog.message",
                new String[] { session.getSelfName() }));
    }

    // IB Action
    public void cancel(Object sender) {
        window().orderOut(null);
		
        session.doShioriEvent("OnVanishCancel");
    }

    // IB Action
    public void vanish(Object sender) {
        window().orderOut(null);
		
        SCFoundation.sharedFoundation().startVanishSession(session);
    }
    
    public void showWindow(final Object sender) {
        // \ׂʒuvZB
        // ʒցB
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    final int windowWidth  = (int)window().frame().width();
                    final int windowHeight = (int)window().frame().height();
                    final int screenWidth  = (int)NSScreen.mainScreen().frame().width();
                    final int screenHeight = (int)NSScreen.mainScreen().frame().height();
                    
                    int x = (screenWidth - windowWidth) / 2;
                    int y = (screenHeight - windowHeight) / 2;
                    
                    window().setFrameOrigin(new NSPoint(x, y));
                    SCVanishWindowController.super.showWindow(sender);

                    return null;
                }
            });
    }
    
    public void show() {
        SCCommandManager.sharedManager().exec(
            new SCCommandManager.Command() {
                public Object run() {
                    
                    if (!window().isVisible()) {
                        // OnVanishSelectings
                        session.doShioriEvent("OnVanishSelecting");
		
                        showWindow(null);
                    }
                    return null;
                }
            });
    }
}
